# Candidate components

Components to investigate and evaluate for fit and purpose.

## Network
* [ZeroTier](https://www.zerotier.com/)
  > ... a distributed network hypervisor built atop a cryptographically secure global peer to peer network. It provides advanced network virtualization and management capabilities on par with an enterprise SDN switch, but across both local and wide area networks and connecting almost any kind of app or device.
* [NetMaker](https://www.netmaker.org/)
  > ... a tool for creating and managing virtual overlay networks. If you have at least two machines with internet access which you need to connect with a secure tunnel, Netmaker is for you. If you have thousands of servers spread across multiple locations, data centers, or clouds, Netmaker is also for you. Netmaker connects machines securely, wherever they are.
* [Nebula](https://slack.engineering/introducing-nebula-the-open-source-global-overlay-network-from-slack/)
  > ... an overlay networking tool designed to be fast, secure, and scalable. Connect any number of hosts with on-demand, encrypted tunnels that work across any IP networks and without opening firewall ports.
* [InnerNet](https://blog.tonari.no/introducing-innernet)
  > A private network system that uses WireGuard under the hood. ... similar in its goals to Slack's nebula or Tailscale, but takes a bit of a different approach. It aims to take advantage of existing networking concepts like CIDRs and the security properties of WireGuard to turn your computer's basic IP networking into more powerful ACL primitives.
* [GNUNet](https://www.gnunet.org/en/about.html)
  > ... an alternative network stack for building secure, decentralized and privacy-preserving distributed applications. Our goal is to replace the old insecure Internet protocol stack. Starting from an application for secure publication of files, it has grown to include all kinds of basic protocol components and applications towards the creation of a GNU internet.

## Storage
* [SeaweedFS](https://github.com/chrislusf/seaweedfs)
  > ... an open-source, simple, and highly scalable distributed file system to store and serve billions of files fast. It is very similar to other file systems including, Ceph, GlusterFS, and HDFS. It can be easily integrated with the cloud and achieve both fast access time without any client-side changes. It has a rich set of features including, Automatic master servers failover, Automatic entry TTL expiration, Parallel processing, Handle large and small files, Low-latency access to any file, and many more.
* [Tahoe-LAFS](https://tahoe-lafs.readthedocs.io/en/latest/about-tahoe.html)
  > ... a system that helps you to store files. You run a client program on your computer, which talks to one or more storage servers on other computers. When you tell your client to store a file, it will encrypt that file, encode it into multiple pieces, then spread those pieces out among multiple servers. The pieces are all encrypted and protected against modifications. Later, when you ask your client to retrieve the file, it will find the necessary pieces, make sure they haven’t been corrupted, reassemble them, and decrypt the result.

## Email
* [poste.io](https://poste.io/)
  > Full stack mailserver solution with TLS support. POP3, SMTP, IMAP, RSPAMD, Clamav, Roundcube, SPF & DKIM with simple installation and web administration.
* [mail-crypt-plugin](https://doc.dovecot.org/configuration_manual/mail_crypt_plugin/)
  > The Mail crypt plugin is used to secure email messages stored in a Dovecot system. Messages are encrypted before written to storage and decrypted after reading. Both operations are transparent to the user.
  > There can be a single encryption key for the whole system or each user can have a key of their own. The used cryptographical methods are widely used standards and keys are stored in portable formats, when possible.
* [mailserver2/mailserver](https://github.com/mailserver2/mailserver)
* [docker-mailserver](https://docker-mailserver.github.io/docker-mailserver/edge/introduction/)
* [Zeyple](https://infertux.com/labs/zeyple/)
  > ... catches email from the postfix queue, then encrypts it if a corresponding recipient's GPG public key is found. Finally, it puts it back into the queue.

## Management
* [Nebula manager](https://nebula-orchestrator.github.io/) (not related to Slack's Nebula)
  > ... a open source distributed Docker orchestrator designed for massive scales (tens of thousands of servers/worker devices), unlike Mesos/Swarm/Kubernetes it has the ability to have workers distributed on high latency connections (such as the internet) yet have the pods(containers) be managed centrally with changes taking affect (almost) immediately, this makes Nebula ideal for managing a vast cluster of servers\devices across the globe ...
